setwd("/Users/Mir/Dropbox/Agreement_ZH/12_PPP_xx/NKJP/")

library(XML)
htmlfile <- readHTMLTable("nkjp_quant_predadj.html", header=FALSE, as.data.frame=TRUE, stringsAsFactors=FALSE)

#Ist dann aber noch immer kein data frame, sondern eine Liste (überprüfen)
class(htmlfile)

#In Dataframe umwandeln
df <- as.data.frame(htmlfile)

#Sinnvolle Spaltennamen zuweisen
colnames(df) <- c("LeftContext", "KWIC", "RightContext")

#KWIC-Spalte extrahieren
kwic <- df$KWIC

x <- gsub("\\[|\\]", "", kwic)

#Wortformen von Grammar-Tags abspalten
tmp <- strsplit(x, " ")

#Liste in einen Dataframe umwandeln
dfnew <- as.data.frame(matrix(unlist(tmp), ncol=10,byrow=TRUE))

#Sinnvolle Spaltennamen zuweisen
colnames(dfnew) <- c("unspecified_form", "unspecified_morph","numeral_form", "numeral_morph","NP_form", "NP_morph","pred_form", "pred_morph","adj_form", "adj_morph")

#alte KWIC-Spalte in ursprünglicher Tabelle löschen
df2 <- subset(df, select=-c(KWIC))

#neue an alte Tabelle anfügen
new <- cbind(df2,dfnew)

#Spalten in sinnvolle Reihenfolge bringen
new_reordered <- new[,c(1,3:11,2)]

    #Eigentlich müsste man nun noch die ganzen Grammar-Tags aufspalten

#Neu generierte Tabelle als csv speichern
write.table(new_reordered, file="nkjp_quant_pred_adj.csv", quote=FALSE, sep="\t", col.names=TRUE, row.names=FALSE, fileEncoding="UTF-8")