setwd("/Users/Mir/Dropbox/Agreement_ZH/12_PPP_xx/NKJP/")

library(XML)
#hnk <- ldply(xmlToList("conc.xml"), data.frame)
#hnk

hnk <- xmlInternalTreeParse("conc.xml")

table(xpathSApply(hnk, "//concordance/child::node()", xmlName))

table(xpathSApply(hnk, "//concordance/lines/line/child::node()", xmlName))

z <- getNodeSet(hnk, "//concordance/lines/line")

df <- xmlToDataFrame(z)

#KWIC-Spalte extrahieren
kwic <- df$kwic

mode(kwic)

kwic.char <- as.character(kwic)

#Leerschläge am Zeilenanfang und Ende entfernen
#t.x <- gsub("  <P> //", "", kwic.char)
t.x <- gsub("</p>", "", kwic.char)
t.a <- gsub("^[ ]| $", "",t.x)

t.b <- gsub("[ ]{2}| /", "@", t.a)

t.c <- gsub("/([CVAN])", "@\\1", t.b)

t.d <- gsub("@/@", "@NA@NA@", t.c)

#Wortformen von Grammar-Tags abspalten
tmp <- strsplit(t.d, "@")

#Liste in einen Dataframe umwandeln
dfnew <- as.data.frame(matrix(unlist(tmp), ncol=15,byrow=TRUE))

#Sinnvolle Spaltennamen zuweisen
colnames(dfnew) <- c("BE_form", "BE_lemma", "BE_morph","unspecified_form", "unspecified_lemma", "unspecified_morph", "NP.f_form", "NP.f_lemma", "NP.f_morph", "i_form", "i_lemma", "i_morph", "NP.n_form", "NP.n_lemma", "NP.n_morph")

#alte KWIC-Spalte in ursprünglicher Tabelle löschen
df2 <- subset(df, select=-c(kwic))

#neue an alte Tabelle anfügen
new <- cbind(df2,dfnew)

#Spalten in sinnvolle Reihenfolge bringen
new_reordered <- new[,c(1:2,4:18,3)]

#Neu generierte Tabelle als csv speichern
write.table(new_reordered, file="hnk_conj_subj.csv", quote=FALSE, sep="\t", col.names=TRUE, row.names=FALSE, fileEncoding="UTF-8")
